GNU Typist - Typing Tutor
*************************

This manual is for GNU Typist (version 2.7, 28 September 2003), a
program to learn typing in several languages and for different keyboard
layouts.

   Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003 Free Software
Foundation, Inc.

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.1 or any later version published by the Free Software
     Foundation; with no Invariant Sections, with the Front-Cover texts
     being "A GNU Manual," and with the Back-Cover Texts as in (a)
     below.  A copy of the license is included in the section entitled
     "GNU Free Documentation License."

     (a) The FSF's Back-Cover Text is: "You have freedom to copy and
     modify this GNU Manual, like GNU software.  Copies published by
     the Free Software Foundation raise funds for GNU development."

GNU Typist is an interactive typing tutor that can help you to type
correctly. It has several lessons for different keyboard layouts and in
different languages. The lessons for gtypist are described in a
easy-to-learn scripting language that the user can use to modify the
existing lessons or create new ones.

Distribution
************

GNU Typist (or gtypist) is "free software"; this means that everyone is
free to use it and free to redistribute it on certain conditions.  The
precise conditions are found in the GNU General Public License that
comes with this program and also follows this section.

You can obtain GNU Typist from a friend or from the Internet:

Primary distribution site
     `ftp://ftp.gnu.org/gnu/gtypist/'

Alternate distribution site
     `http://gtypist.org/releases/'

Home page
     `http://www.gnu.org/software/gtypist/'

Alternate home page
     `http://gtypist.org/'

On-line manual (updates between program releases)
     `http://www.gnu.org/software/gtypist/doc/'

Developers' home page (CVS repository, tasks, support...)
     `http://savannah.gnu.org/projects/gtypist/'

GNU Typist download page (sources, binaries and tutorial updates)
     `http://gtypist.org/'

Screenshots
     `http://gtypist.org/screenshots/'

GNU GENERAL PUBLIC LICENSE
**************************

                         Version 2, June 1991
     Copyright (C) 1989, 1991 Free Software Foundation, Inc.
     675 Mass Ave, Cambridge, MA 02139, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

Preamble
========

The licenses for most software are designed to take away your freedom
to share and change it.  By contrast, the GNU General Public License is
intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it.  (Some other Free Software Foundation software is covered by
the GNU Library General Public License instead.)  You can apply it to
your programs, too.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it in
new free programs; and that you know you can do these things.

   To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

   For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

   We protect your rights with two steps: (1) copyright the software,
and (2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

   Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

   Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

   The precise terms and conditions for copying, distribution and
modification follow.

    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
  1. This License applies to any program or other work which contains a
     notice placed by the copyright holder saying it may be distributed
     under the terms of this General Public License.  The "Program",
     below, refers to any such program or work, and a "work based on
     the Program" means either the Program or any derivative work under
     copyright law: that is to say, a work containing the Program or a
     portion of it, either verbatim or with modifications and/or
     translated into another language.  (Hereinafter, translation is
     included without limitation in the term "modification".)  Each
     licensee is addressed as "you".

     Activities other than copying, distribution and modification are
     not covered by this License; they are outside its scope.  The act
     of running the Program is not restricted, and the output from the
     Program is covered only if its contents constitute a work based on
     the Program (independent of having been made by running the
     Program).  Whether that is true depends on what the Program does.

  2. You may copy and distribute verbatim copies of the Program's
     source code as you receive it, in any medium, provided that you
     conspicuously and appropriately publish on each copy an appropriate
     copyright notice and disclaimer of warranty; keep intact all the
     notices that refer to this License and to the absence of any
     warranty; and give any other recipients of the Program a copy of
     this License along with the Program.

     You may charge a fee for the physical act of transferring a copy,
     and you may at your option offer warranty protection in exchange
     for a fee.

  3. You may modify your copy or copies of the Program or any portion
     of it, thus forming a work based on the Program, and copy and
     distribute such modifications or work under the terms of Section 1
     above, provided that you also meet all of these conditions:

       a. You must cause the modified files to carry prominent notices
          stating that you changed the files and the date of any change.

       b. You must cause any work that you distribute or publish, that
          in whole or in part contains or is derived from the Program
          or any part thereof, to be licensed as a whole at no charge
          to all third parties under the terms of this License.

       c. If the modified program normally reads commands interactively
          when run, you must cause it, when started running for such
          interactive use in the most ordinary way, to print or display
          an announcement including an appropriate copyright notice and
          a notice that there is no warranty (or else, saying that you
          provide a warranty) and that users may redistribute the
          program under these conditions, and telling the user how to
          view a copy of this License.  (Exception: if the Program
          itself is interactive but does not normally print such an
          announcement, your work based on the Program is not required
          to print an announcement.)

     These requirements apply to the modified work as a whole.  If
     identifiable sections of that work are not derived from the
     Program, and can be reasonably considered independent and separate
     works in themselves, then this License, and its terms, do not
     apply to those sections when you distribute them as separate
     works.  But when you distribute the same sections as part of a
     whole which is a work based on the Program, the distribution of
     the whole must be on the terms of this License, whose permissions
     for other licensees extend to the entire whole, and thus to each
     and every part regardless of who wrote it.

     Thus, it is not the intent of this section to claim rights or
     contest your rights to work written entirely by you; rather, the
     intent is to exercise the right to control the distribution of
     derivative or collective works based on the Program.

     In addition, mere aggregation of another work not based on the
     Program with the Program (or with a work based on the Program) on
     a volume of a storage or distribution medium does not bring the
     other work under the scope of this License.

  4. You may copy and distribute the Program (or a work based on it,
     under Section 2) in object code or executable form under the terms
     of Sections 1 and 2 above provided that you also do one of the
     following:

       a. Accompany it with the complete corresponding machine-readable
          source code, which must be distributed under the terms of
          Sections 1 and 2 above on a medium customarily used for
          software interchange; or,

       b. Accompany it with a written offer, valid for at least three
          years, to give any third party, for a charge no more than your
          cost of physically performing source distribution, a complete
          machine-readable copy of the corresponding source code, to be
          distributed under the terms of Sections 1 and 2 above on a
          medium customarily used for software interchange; or,

       c. Accompany it with the information you received as to the offer
          to distribute corresponding source code.  (This alternative is
          allowed only for noncommercial distribution and only if you
          received the program in object code or executable form with
          such an offer, in accord with Subsection b above.)

     The source code for a work means the preferred form of the work for
     making modifications to it.  For an executable work, complete
     source code means all the source code for all modules it contains,
     plus any associated interface definition files, plus the scripts
     used to control compilation and installation of the executable.
     However, as a special exception, the source code distributed need
     not include anything that is normally distributed (in either
     source or binary form) with the major components (compiler,
     kernel, and so on) of the operating system on which the executable
     runs, unless that component itself accompanies the executable.

     If distribution of executable or object code is made by offering
     access to copy from a designated place, then offering equivalent
     access to copy the source code from the same place counts as
     distribution of the source code, even though third parties are not
     compelled to copy the source along with the object code.

  5. You may not copy, modify, sublicense, or distribute the Program
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense or distribute the Program is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

  6. You are not required to accept this License, since you have not
     signed it.  However, nothing else grants you permission to modify
     or distribute the Program or its derivative works.  These actions
     are prohibited by law if you do not accept this License.
     Therefore, by modifying or distributing the Program (or any work
     based on the Program), you indicate your acceptance of this
     License to do so, and all its terms and conditions for copying,
     distributing or modifying the Program or works based on it.

  7. Each time you redistribute the Program (or any work based on the
     Program), the recipient automatically receives a license from the
     original licensor to copy, distribute or modify the Program
     subject to these terms and conditions.  You may not impose any
     further restrictions on the recipients' exercise of the rights
     granted herein.  You are not responsible for enforcing compliance
     by third parties to this License.

  8. If, as a consequence of a court judgment or allegation of patent
     infringement or for any other reason (not limited to patent
     issues), conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot distribute so as to satisfy simultaneously
     your obligations under this License and any other pertinent
     obligations, then as a consequence you may not distribute the
     Program at all.  For example, if a patent license would not permit
     royalty-free redistribution of the Program by all those who
     receive copies directly or indirectly through you, then the only
     way you could satisfy both it and this License would be to refrain
     entirely from distribution of the Program.

     If any portion of this section is held invalid or unenforceable
     under any particular circumstance, the balance of the section is
     intended to apply and the section as a whole is intended to apply
     in other circumstances.

     It is not the purpose of this section to induce you to infringe any
     patents or other property right claims or to contest validity of
     any such claims; this section has the sole purpose of protecting
     the integrity of the free software distribution system, which is
     implemented by public license practices.  Many people have made
     generous contributions to the wide range of software distributed
     through that system in reliance on consistent application of that
     system; it is up to the author/donor to decide if he or she is
     willing to distribute software through any other system and a
     licensee cannot impose that choice.

     This section is intended to make thoroughly clear what is believed
     to be a consequence of the rest of this License.

  9. If the distribution and/or use of the Program is restricted in
     certain countries either by patents or by copyrighted interfaces,
     the original copyright holder who places the Program under this
     License may add an explicit geographical distribution limitation
     excluding those countries, so that distribution is permitted only
     in or among countries not thus excluded.  In such case, this
     License incorporates the limitation as if written in the body of
     this License.

 10. The Free Software Foundation may publish revised and/or new
     versions of the General Public License from time to time.  Such
     new versions will be similar in spirit to the present version, but
     may differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies a version number of this License which applies
     to it and "any later version", you have the option of following
     the terms and conditions either of that version or of any later
     version published by the Free Software Foundation.  If the Program
     does not specify a version number of this License, you may choose
     any version ever published by the Free Software Foundation.

 11. If you wish to incorporate parts of the Program into other free
     programs whose distribution conditions are different, write to the
     author to ask for permission.  For software which is copyrighted
     by the Free Software Foundation, write to the Free Software
     Foundation; we sometimes make exceptions for this.  Our decision
     will be guided by the two goals of preserving the free status of
     all derivatives of our free software and of promoting the sharing
     and reuse of software generally.

                                NO WARRANTY

 12. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
     HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT
     WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT
     NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE
     QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
     PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY
     SERVICING, REPAIR OR CORRECTION.

 13. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
     DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
     OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY
     OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

                      END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND AN IDEA OF WHAT IT DOES.
     Copyright (C) 19YY  NAME OF AUTHOR

     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Also add information on how to contact you by electronic and paper
mail.

   If the program is interactive, make it output a short notice like
this when it starts in an interactive mode:

     Gnomovision version 69, Copyright (C) 19YY NAME OF AUTHOR
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details
     type `show w'.  This is free software, and you are welcome
     to redistribute it under certain conditions; type `show c'
     for details.

   The hypothetical commands `show w' and `show c' should show the
appropriate parts of the General Public License.  Of course, the
commands you use may be called something other than `show w' and `show
c'; they could even be mouse-clicks or menu items--whatever suits your
program.

   You should also get your employer (if you work as a programmer) or
your school, if any, to sign a "copyright disclaimer" for the program,
if necessary.  Here is a sample; alter the names:

     Yoyodyne, Inc., hereby disclaims all copyright
     interest in the program `Gnomovision'
     (which makes passes at compilers) written
     by James Hacker.

     SIGNATURE OF TY COON, 1 April 1989
     Ty Coon, President of Vice

   This General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Library General Public License instead of this License.

Introduction
************

GNU Typist is an interactive typing tutor program. It uses an input
file to create a series of typing tutorials, drills, and speed tests. It
is intended to be used on raw terminals without graphics -it has been
compiled and used in GNU/Linux and Unix (OpenBSD, AIX, Solaris) and
also in DOS/Windows (DOS 6.22, Windows 95, 98, NT and XP).

   The program reads lessons written in an easy-to-learn scripting
language. It is distributed with several complete and good lessons. You
can use them, modify them or create new lessons (see Create new lessons
and Script file commands).

   If a script file is not specified on the command line, a default file
`gtypist.typ' will be used. (See details about the path in the section
Environment Variables).

   The top line of the screen displays a banner. The bottom line of the
screen displays a message line, queries, and other status information.
The lines in between are used for the tutorials, drills, and speed
tests.

   There are two types of typing exercises: "drills" and "speed tests".

   In a "drill", gtypist displays text in every other line on the
screen, and waits for the user to correctly type the exact same text in
the intermediate lines.  Typing errors are indicated with an inverse
`^', or `>' if the character is a newline and at the end of the
exercise it calculates the real and effective rate in Words Per Minute
(WPM).  If there were too many errors, it will re-run the drill.

   Backward deleting of previously typed characters to correct errors is
not allowed.

   In a speed test, gtypist displays text on the screen, and waits for
the user to correctly over-type the exact same text. It indicates typing
errors, and at the end of the test it calculates the real and effective
rate in WPM.  If there were too many errors, it will re-run the speed
test.  Backward deleting of previously typed characters to correct
errors is permitted, but errors still accumulate.

   If you already made too many mistakes, then you can use <ESC> to
give up and start again. You can also skip a lesson by pressing <ESC>
twice. Once you complete a lesson, you will be asked whether you want
to repeat it.

   There are also "practice only" exercises (of both drills and speed
tests) which you won't have to repeat at all. But we won't tell you
when this is the case, so you'll have to give your best anyway ;-)

   In typing speed reports, a "word" is deemed to be five characters, so
the raw (gross) WPM is the number of characters in the test passage,
divided by five, then divided again by the number of minutes elapsed in
typing the passage. The adjusted WPM factors in the errors; each error
is counted as a mistyped word.

Invoking
********

The syntax to invoke GNU Typist is:

   `gtypist [ Options... ] [ script_file ]'

   The supported options are given below (note that the long form is
not supported on DOS):

`-e, --error-max'
     Specifies the default maximum error percentage.  The default value
     is 3.0 and it must be between 0.0 and 100.0. There is a
     corresponding script file command (see Script file commands)
     which only overrides this if it is _stricter_ (smaller). This
     value is ignored for "practice only" drills.

`-n, --notimer'
     gtypist will display the typing speeds in WPM after both drills
     and speed tests. However, the lessons appear to be written for a
     program that only does this for speed tests. To make gtypist
     behave in a manner that matches the lessons, that is, to sup WPM
     reports on drills, use `-n' or `--notimer'.

`-t, --term-cursor'
     gtypist creates its own flashing block cursor on the screen, to
     help distinguish between the cursor and reverse video error
     indications.  Setting `-t' or `--term-cursor' suppresses this, and
     forces the program to use the terminal's cursor instead.

`-f, --curs-flash'
     Sets the block cursor flash period in tenths of a second. A value
     of 0 indicates no cursor flashing. The default is 10, and the
     maximum is 512. This option is ignored if `-t' or `--term-cursor'
     has been set.

`-c, --colo[u]rs'
     In normal operation, gtypist uses only normal and reverse video
     attributes in monochrome mode. This option may be used to specify
     the foreground and background colours on terminals that support
     colours.  The colours are specified as two integers, in the range
     0 to 7, separated by commas, setting the foreground and background
     colours. The colour codes 0 to 7 indicate black, red, green,
     yellow, blue, magenta, cyan, and white respectively. The default
     colours string is 7,0 - white on black. The option is ignored if
     the terminal does not support colours.

`-s, --silent'
     When gtypist detects a typing error, it will beep the terminal.
     Use this option to silence the beep.

`-q, --quiet'
     Same as `-s' or `--silent'.

`-w, --wpmode'
     With this option, gtypist will try to mimic a word processor in
     certain ways when executing an exercise. It will treat space at
     the end of a line as a correctly typed character, and word wrap.
     It will treat return at the end of a line as a signal to move to
     the start of the next paragraph if applicable. It will compress
     multiple spaces into a single space. And it will skip over hyphens
     found at the end of a line.

`-l, --start-label'
     Specifies the label in the script file at which gtypist begins
     executing (see script files and commands below for information on
     labels). If this option is not used, gtypist begins execution at
     the first line of the file.

`-k, --no-skip'
     Prohibit the user from skipping lessons or exiting from lessons via
     <ESC ESC>.

You also have to set the environment variable `LANG' if you want to run
gtypist in your native language. See Environment Variables.

In some languages like French, some interface messages are longer than
in English. Therefore, you may need to make your terminal larger before
invoking the tool. Otherwise, the text on the lower left may overlap
with the string on the lower right.

   *Examples:*

To run the default lessons of lesson `gtypist.typ':
`gtypist'

To run the lesson in Spanish:
`gtypist esp.typ'

To instruct gtypist to look for lesson bar.typ in a non standard
directory `/home/foo':
`export GTYPIST_PATH="/home/foo"' `gtypist bar.typ'

To run the lessons in the file `test.typ' of directory `/tmp', starting
at label `TEST1', using the terminal's cursor, and running silently:
`gtypist -t -q -l TEST1 /tmp/test.typ'

Supplied lessons
****************

The following lessons are supplied with GNU Typist :
`q.typ'
     Quick QWERTY course in English

`r.typ'
     Long QWERTY course in English

`t.typ'
     QWERTY touch typing in English

`v.typ'
     Yet Another QWERTY in English

`w.typ'
     QWERTY Review in English

`d.typ'
     Dvorak touch typing in English

`m.typ'
     Typing drills in English

`s.typ'
     Speed drills in English

`n.typ'
     Calculator keypad in English

`gtypist.typ'
     Compendium of all previous lessons in English

`esp.typ'
     QWERTY course in Spanish

`cs.typ'
     Lessons in Czech

`ru.typ'
     Lessons in Russian

`kt*.typ'
     These lessons are the standard lessons from Ktouch 1.0
     (http://ktouch.sourceforge.net/), which have been converted to
     gtypist's file format using `tools/ktouch2typ.pl'.

     The files are called `ktde.typ' (`german.ktouch'), `kten.typ'
     (`english.ktouch'), `ktfr.typ' (`french.ktouch'), `ktfr2.typ'
     (`french-2.ktouch'), `ktno.typ' (`norwegian.ktouch') `ktdk.typ'
     (`danish.ktouch'), `ktdk2.typ' (`danish-2.ktouch'), `ktdvorak.typ'
     (`dvorak.ktouch') and `ktnumber.typ' (`number.ktouch').

`ttde.typ'
     This is the German lesson of tipptrainer
     (http://www.pingos.schulnetz.org/tipptrainer/), which has been
     converted using `tools/tt2typ.pl'.

If you find errors in these lessons, if you modify any of them or if you
write a new lesson, please release it with a free license and tell us
about it, by writing an email to <bug-gtypist@gnu.org>.

Using typefortune
*****************

`typefortune' lets you practice with text from `fortune'.

   `SYNTAX: typefortune [-dslh] [-n count] [-o <gtypist_opts>]'

`-d'
     Use `D:' instead of `S:'.

`-s'
     Run fortune with `-s'.

`-l'
     Run fortune with `-l'.

`-n <count>'
     Practice <count> fortunes.

`-o <gtypist_options>'
     Pass options to gtypist, in the form `option' (boolean option,
     i.e. `-o word-processor'), `option,value' (option with value, i.e.
     `-o e,1.0') where `option' is the name of the option (short or
     long) with all leading dashes removed.  You need to quote the
     argument to `-o' if you are specifying more than one argument:
     `typefortune -n 3 -o 'silent e,5 word-processor''.

Script file commands
********************

GNU Typist reads in the data for its typing lessons from a script file.
With the exception of comments and blank lines, each line in the file is
of the format

   `command_char : command_data'

Here, `command_char' is a single character code that defines an action
for gtypist to take, and `command_data' is data for that command. If
`command_char' is a space character, this indicates that the line is a
continuation of the preceding non-space command. The `:' separator must
be in column two of the line.

   Comment lines are lines beginning with a `#' character, and are
ignored, as are blank lines. Comment lines may have any format provided
that they begin with `#'; other lines must have the above format.

   You should read the introduction so that you are familiar with the
basics: Introduction.

   The following is a list of valid `command_char' values:

`B'
     This command clears the complete screen. If any `command_data' is
     present, it is displayed in the one-line banner at the top of the
     screen, and remains in place until the next `B' command. This
     command may not be continued on the following line; it is a single
     line command.

`T'
     This presents a tutorial, and is a multi-line command, up to the
     limit of the screen length. Each line in the command is simply
     printed to the screen. This command clears the screen beneath the
     top banner line. After the display is done, the program waits
     before proceeding.

`*'
     This indicates a label in the file. The label may be the target of
     a `G', `Y', `N' or `F' command. Labels may contain any character,
     including space, and are a single line command. Labels must be
     unique within lesson files. Whitespace at the end of labels is
     ignored.

`I'
     The `I' command can display some brief instructions above a drill
     or a speed test.  Only two lines or less are permitted.  Unlike the
     `T' command, it does not wait for any further keypresses before
     proceeding.  So it should really always be followed by an exercise.
     It clears the whole screen exercise area, so in this respect it's
     just like a two-line `T'.

`M'
     This command is the new way to create menus (since gtypist 2.7).
     Here is the syntax:
          M: [UP=(LABEL|_EXIT)] "title"
           :LABEL1 "description1"
           :LABEL2 "description2"
           ...

     The UP-label indicates the parent-menu's label which defines the
     last menu-item (if it's _EXIT "Exit", else the last menu-item "Up"
     will jump to the specified label). It is optional: if it is not
     supplied, the special value _EXIT is used.

     The title and all descriptions must be wrapped in quotes ("").
     Additionally, there must be at least one space between UP=XXX and
     "title" and between the labels and the corresponding descriptions.

     See the existing lesson-files for examples.

`D,d'
     This command is called "drill", and it is one of two types of
     typing exercises.

     It is a multi-line command. The text is displayed in every second
     line, and you type in the intermediate lines. Because of this, you
     cannot use more than 11 lines of drill content.

     This type of exercise is supposed to be used for finger training
     (i.e. jfjfjjf), but may also contain complete words and sentences
     if they are used to practice something (i.e. a
     letter/syllable/"grip"), and aren't real texts.

     The lowercase version `d' is a "practice only" drill - the user
     will not have not repeat this drill if he/she made too many
     mistakes.

`S,s'
     This is the second type of typing exercise: the "speed test".

     It is a multi-line command.  It displays its text on the screen,
     and prompts the user to type on top of it.  That's why you can use
     up to 22 lines of text for one speed test.  In a speed test you
     can correct your mistakes, but this will not decrease the
     error-count.

     Speed tests should be used for typing (mostly) complete sentences,
     texts or files (i.e. a letter, texinfo/html/tex files).

     The lowercase version `s' is a "practice only speed test": the
     user will not have not repeat this drill if (s)he made too many
     mistakes.

`G'
     This causes gtypist to go to the label in `command_data', and
     continue execution of the script there. This is a single line
     command.

`Q'
     This command command prompts its text on the message line, and
     waits for a <Y> or an <N> before proceeding. Other characters are
     ignored.

     As a side effect, you can hit an Fkey if it is bound (a deprecated
     way to create the prompt for menus).

`Y'
     This is like `G', except that the goto is executed only if the
     result of the last `Q' command was <Y>.

`N'
     This is like `G', except that the goto is executed only if the
     result of the last `Q' command was <N>.

`K'
     _This command is deprecated in favor of M:_ This binds a function
     key to a label. The format of the data line following this command
     must be `fkey_number:label', where `fkey_number' is a function key
     number in the range 1 to 12, and `label' is a label to go to when
     this key is pressed. A value of NULL for label removes any label
     binding from the key.

     If function keys are not available on the terminal other keys can
     be used: <1> to <9> to replace <F1> to <F9>, <0> to replace <F10>,
     <A> for <F11> and <S> for <F12>.

     Other alternatives for the keys <F1> to <F12> are the
     combinations: <Ctrl-Q>, <Ctrl-W>, <Ctrl-E>, <Ctrl-R>, <Ctrl-T>,
     <Ctrl-Z>, <Ctrl-U>, <Ctrl-I>, <Ctrl-O>, <Ctrl-P>, <Ctrl-A> and
     <Ctrl-S>.

     This is also useful where function keys are intercepted by other
     programs (for example by a window manager).

`E'
     This command is used to set the highest error-rate permitted for
     the next drill (`E:<value>%') or for all following drills until
     the next `E:' (`E:<value>%*').

     If `--error-max/-e' is specified then this command will only have
     an effect if it is _stricter_ than the value specified on the
     command-line.

     `command_data' consists of the value (between 0.0 and 100.0),
     followed by `%' (this is required so that scripts are more
     readable).  A special value of `default' or `Default' sets the
     error-max value back to the default.

`F'
     This command ("set on-failure label") is used to set the label (in
     `command_data') where the user will have to go to if (s)he fails
     an exercise.

     Usually, this command only applies to the next exercise, but you
     can make it persistent by putting a `*' at the end of
     `command_data'.

     If label is NULL then this resets the label.

`X'
     This command causes gtypist to exit. It is a single line command.
     Any `command_data' is ignored. The program also exits if the end
     of the file is found (so you could also place a label there and
     just `G' to it)

   Here is a tiny example script to demonstrate the available commands
(`tinydemo.typ' lesson file):

     # Minimal demonstration
     B: Typing tutor demonstration
     *:LOOP
     K:1:QDONE
     T:This is a small example tutor script. A better
      :example may be found in the demo.typ file that
      :accompanies GNU Typist
     I:Here is an example of a drill:
     D:asdf ghjkl;
     I:And here is an example of a speed test:
     S:qwe rt yu iop
     *:QDONE
     Q:Seen enough yet? [Y/N]
     N:LOOP
     X:

Create new lessons
******************

This section provides guidelines and hints for creating new lessons (or
improving existing ones).

Ktouch lessons
==============

A very easy way to write lessons is to write them in the format that
`ktouch' uses, and then convert it to a gtypist lesson using
`tools/ktouch2typ.pl'. This will take care of writing "jump-tables", a
menu and a bit more.

   The ktouch-format consists only of lessons, which are preceded by
their names, and separated by blank lines and/or comments (`#' at the
beginning of the line). So the first non-blank, non-comment line in the
file is the name of the first lesson, and the first lesson consists of
all the lines up to the next comment or blank line. After the separator
(comment or blank line) the name of the second lesson follows and so on.

   This is an example of a three-lesson ktouch file (excerpts from the
first three lessons of `german.ktouch'):
     #
     # Deutsche Training-Datei für KTouch
     #

     Grundstellung
     f f f f f f fff fff fff f f f f f f fff fff fff f f f f f f f fff
     j j j j j j jjj jjj jjj j j j j j j jjj jjj jjj j j j j j j j jjj
     fff jjj fff jjj jjj fff jjj fff fjf fjf fjf jfj jfj jfj fjf jfjfj

     Grundstellung
     fff jjj ddd kkk aaa ööö fff jjj ddd kkk aaa ööö fff jjj ddd kkkff
     fda jkö fda jkö fda jkö fda jkö fda jkö fda jkö fda jkö fda jköfd
     s s s s s s sss sss sss s s s s s s sss sss sss s s s s s s s sss

     #Zwei wichtige Vokale: e und i
     e und i
     asdf ölkj fdsa jklö asdf ölkj fdsa jklö asdf ölkj fdsa jklö asdfö
     das dass lös fad dass lös als dass las lös fad dass als dass dass
     ded ded ded dej dek del deö ded deö del dek dej ded dej dek delde

   Once you are done, use `tools/ktouch2typ.pl' to convert the file:
`ktouch2typ.pl lesson.ktouch' converts `lesson.ktouch' to `lesson.typ'.
It is important that the input file ends in `.ktouch', otherwise
`ktouch2typ.pl' will skip it. Warning: this will overwrite `lesson.typ'
without asking you !

   You can customize the number of lines that `ktouch2typ.pl' uses for
each drill by modifying the relevant variable in `tools/ktouch2typ.pl'.

   Obviously, the disadvantage of this is that you cannot make use of
all of gtypist's features (but the output file is very readable, so you
can edit it to use more of gtypist's features).

Exercises from fortune
======================

Using `gtypist-mode.el' you can quickly create lessons with text from
the program `fortune' (or the emacs-internal `yow' if `fortune' isn't
available, as is usually the case on Windows).

   Once you installed `gtypist-mode.el' (see Emacs mode), you can
open a file with the `.typ' extension and run `C-c C-f' to create a
drill (`D:' by default, use `C-u' or `C-u C-u' prefix to change).

Design patterns for lessons
===========================

Structure of lesson files
-------------------------

   * Use mixture of drills and speed tests (this is more fun for the
     user)

   * Use some "practice-only" exercises (`d:'/`s:') (possibly mixed
     with "real" exercises) followed by a "final test".  `esp.typ' uses
     this scheme.

Patterns for exercises
----------------------

   * When introducing a new key, start out by mixing other (known) keys
     of the same finger in with the new key in the first drill(s).
     Here is an example (from `t.typ', line 237):
          I:Use your J-finger for the H key.
          *:_T_R_L23
          D:jjj jhj jjj jhj jjj jhj

   * use 'word, word.' repeatedly to practice ,/.

Findwords script
================

The `tools/findwords' script in the GNU Typist sources is there to
assist you in creating new lessons.

Purpose
-------

In the beginning when you are creating a new tutorial from scratch,
it's not very easy to form words and even sentences while the range of
letters you can use is restricted. Sometimes you want to insert some
paragraph "targeted" at some special combination of two or three
letters.  This is even harder.

   For this purpose we created findwords. It uses the dictionaries from
the aspell database (free multilingual spellchecker).

Installing
----------

You will need the `aspell' and `aspell-LG' packages, where LG is the
ISO language code for the language you want to use.

   After a successful installation, you will have to make a little
change in your configuration so that aspell's master database is the
one of your language. This can be done two different ways:

  1. In your home directory create the file
     .aspell.conf and add this line:
     `master LANGUAGE'

  2. Create /usr/share/pspell/LG-aspell.pwli
     and add this line:
     `/usr/lib/aspell/LG'
     Make sure your locale setting is LG.

   In the above, LG means ISO language code (eg. `en', `fr', `cs') and
LANGUAGE means name of the database in /usr/lib/aspell (eg.
`english.multi', `french', `czech').

   You can try if it works by typing:
             aspell dump master | less

Using findwords
---------------

The syntax is as follows:
`./findwords letters [combination]'

   In the mandatory `letters' argument you must list the letters that
you want use without any spaces. You may use the dot (`.') to say `all
letters'. The second argument combination is optional and you can
specify there what combination of letters are you searching for.

   Some examples:

   * `./findwords asdfjkleruio'
     We are looking for all words composed from the listed letters.

   * `./findwords asdfjkleruio sa'
     We search words containing the combination `sa', but only these
     composed from specified letters.

   * `./findwords . col'
     Words can contain all letters, but must have `col' somewhere
     inside.

Emacs mode
**********

gtypist now comes with an Emacs major-mode which does
syntax-highlighting, indentation and has some convenient commands for
counting labels, a goto-label-command, inserting properly centered
banners, special comments and a bit more.

   Copy this file from `tools/gtypist-mode.el' to wherever you put your
local elisp files (e.g.  `~/elisp') and put this in your `~/.emacs'
(adapt path!):

     (autoload 'gtypist-mode "~/elisp/gtypist-mode")

   or put it in `load-path' (`make install' in the sources should take
care of this for GNU Emacs, or if you are using the Debian package, it
installs it here for you) and use this instead:

     (autoload 'gtypist-mode "gtypist-mode")

   *and* add this to your `~/.emacs':

     (setq auto-mode-alist
           (cons '("\\.typ\\'" . gtypist-mode) auto-mode-alist))

All this is also mentioned in the README-section of
`tools/gtypist-mode.el'.

Here are the commands along with the keybindings:

`C-c C-i, M-x gtypist-mode-info'
     This shows gtypist's texinfo-documentation, starting at node
     "Script file commands" (see Script file commands). With prefix,
     start at the top-node.

`C-c M-g, M-x gtypist-mode-goto-label'
     Query for a label to go to (with completion).

`C-c C-l, M-x gtypist-mode-next-label'
     This command inserts the next label in a numbered sequence of
     labels.  For example, if you insert
          *:SERIES1_L1
     and hit `C-c C-l' then gtypist-mode will insert
          *:SERIES1_L2

`C-c C-b, M-x gtypist-mode-insert-banner'
     This command inserts a centered `B:' command. It's centered on 66
     columns because "gtypist <version>" is in the right corner
     (prompts for content).

`C-c C-r, M-x gtypist-mode-insert-hrule'
     Inserts a horizontal rule (comment) consisting of dashes.

`C-c C-n, M-x gtypist-mode-new-lesson'
     Insert the comments (header) and a label to start a new lesson
     (prompts for name).

`C-c C-f, M-x gtypist-mode-fortune-to-drill'
     Insert a drill (`D:') with text from `fortune' (or `yow' if
     `fortune' isn't available). Use `C-u' prefix to get `S:', and `C-u
     C-u' to get `d:'.

Run `C-h m' for a complete list of commands and their keybindings.

   If you find bugs or if you think there's something else this mode
could do, please write to <bug-gtypist@gnu.org>.

Environment Variables
*********************

GNU Typist uses the following environment variables:

`LANG'
     GNU Typist offers Native Language Support (NLS) with support of the
     gettext library, this means that if your system supports it, the
     language of the messages shown by gtypist can be chosen. By now
     gtypist is distributed with messages in English, Czech, Finnish,
     French, German and Spanish.  To use a particular NLS use the
     environment variable LANG and set it to the appropriate `LL_CC'
     combination where `LL' is an ISO 639 two-letter language code and
     `CC' is an ISO 3166 two-letter country code (e.g. `es_ES' for
     Spain and `de_DE' for Germany). In some systems it will be also
     necessary to set the environment variable LANGUAGE to the same
     value.

     If you want to translate messages to a different language (or if
     you want to correct a message), please communicate it to
     <bug-gtypist@gnu.org>.

`GTYPIST_PATH'
     Lists the directories that the program will look in for script
     files.  It has the standard format for paths, that is, a list of
     directories separated by `:'s. To open a script, gtypist will try
     the following paths: (1) to use the script name alone (2) it will
     append each one of the directories specified in the variable
     `GTYPIST_PATH' and (3) it will append the directory used during
     the installation process (e.g.  `/usr/local/share/gtypist' or
     `/usr/share/gtypist').

`TERM'
     Used by curses to manage the display.

`TERMINFO'
     This may need to be set if the path to the `terminfo' database is
     different between the system the binary was compiled on and the
     one it is being run on. For example, in older Slackware systems,
     the terminfo database resides in `/usr/lib/terminfo'. On RedHat
     Linux, it is in `/usr/share/terminfo'. If the program complains
     about the terminal type, and the value of `TERM' is correct, check
     into this.

Errors and omissions
********************

GNU Typist does not support multi-byte character encoding yet (such as
UTF-8).  To see all the characters in some lesson files, you have to
make sure that your terminal is run in such an environment in which the
LANG variable is not set to an UTF-8 encoding. Lazy users can also try
just try to run GNU Typist on another type of terminal. It sometimes
works.

   GNU Typist does not go to much effort to minimize terminal output. In
particular, the flashing block cursor can cause a lot of cursor
movement. Using the terminal's own cursor will help if this becomes a
problem.

   In speed tests, the program does not allow backspacing or deletion
past the beginning of the screen line, or back through Tab characters.
This is purely to simplify screen updating.

   Colour curses modes do not seem to work well with UnixWare. In
particular, reverse video is not always rendered correctly on some
terminal types, and xterms.

History of GNU Typist
*********************

   * The initial program was written for VAX/VMS BASIC by someone at
     Harris Corp (Ft. Lauderdale, FL).

   * D. Jason Penney <penneyj@slc.com> rewrote it for Microsoft BASICA

   * D. Jason Penney <penneyj@slc.com> rewrote it in C and the curses
     library

   * Simon Baldwin <simonb@sco.com> rewrote the version of D. Jason
     Penney, his innovations are described in the NEWS file (versions
     2.2 to 2.2b).  He is the holder of the copyright for GNU Typist
     (that is distributed under the GPL).  Simon also wrote a version
     of Typist in Java that initially he called JTypist but that now is
     called Typist again:

     `http://www.geocities.com/simon_baldwin/typist/'

   * Since 1997, Ben Armstrong <synrg@sanctuary.nslug.ns.ca> has helped
     by fixing bugs and maintaining a Debian package
     (http://packages.debian.org/gtypist/).

   * In 2000, Vladimir Támara <vtamara@users.sourceforge.net> and Igor
     Támara <ikks@users.sourceforge.net> became the maintainers of the
     C version. Before November 2000, GNU Typist was maintained as part
     of the Structio project.

   * November 2000, accepted as a GNU package! Renamed to GNU Typist (or
     gtypist).

   * In May 2001, Michael Opdenacker <michaelo@gnu.org>, who learned
     touch typing with GNU Typist, became the new maintainer. Project
     development is now hosted on
     `http://savannah.gnu.org/projects/gtypist/'.

   * In June 2001, Felix Natter <fnatter@gmx.net> joined and made major
     contributions to the project: lesson imports from other tutors,
     tool enhancements, new tutorial capabilities, , Emacs mode, arrow
     key based interface, and many more!

   * In 2003, Dmitry Rutsky <rutsky@school.ioffe.rssi.ru> joined joined
     the development team and brought in a dramatic number ideas, hacks
     and improvements, and he's not done yet!

Copying this manual
*******************

GNU Free Documentation License
==============================

                        Version 1.1, March 2000
     Copyright (C) 2000 Free Software Foundation, Inc.
     59 Temple Place, Suite 330, Boston, MA  02111-1307, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     written document "free" in the sense of freedom: to assure everyone
     the effective freedom to copy and redistribute it, with or without
     modifying it, either commercially or noncommercially.  Secondarily,
     this License preserves for the author and publisher a way to get
     credit for their work, while not being considered responsible for
     modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.
     We recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work that contains a
     notice placed by the copyright holder saying it can be distributed
     under the terms of this License.  The "Document", below, refers to
     any such manual or work.  Any member of the public is a licensee,
     and is addressed as "you".

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter
     section of the Document that deals exclusively with the
     relationship of the publishers or authors of the Document to the
     Document's overall subject (or to related matters) and contains
     nothing that could fall directly within that overall subject.
     (For example, if the Document is in part a textbook of
     mathematics, a Secondary Section may not explain any mathematics.)
     The relationship could be a matter of historical connection with
     the subject or with related matters, or of legal, commercial,
     philosophical, ethical or political position regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in
     the notice that says that the Document is released under this
     License.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, whose contents can be viewed and edited directly
     and straightforwardly with generic text editors or (for images
     composed of pixels) generic paint programs or (for drawings) some
     widely available drawing editor, and that is suitable for input to
     text formatters or for automatic translation to a variety of
     formats suitable for input to text formatters.  A copy made in an
     otherwise Transparent file format whose markup has been designed
     to thwart or discourage subsequent modification by readers is not
     Transparent.  A copy that is not "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and
     standard-conforming simple HTML designed for human modification.
     Opaque formats include PostScript, PDF, proprietary formats that
     can be read and edited only by proprietary word processors, SGML
     or XML for which the DTD and/or processing tools are not generally
     available, and the machine-generated HTML produced by some word
     processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow
     the conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies of the Document numbering more than
     100, and the Document's license notice requires Cover Texts, you
     must enclose the copies in covers that carry, clearly and legibly,
     all these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the
     title equally prominent and visible.  You may add other material
     on the covers in addition.  Copying with changes limited to the
     covers, as long as they preserve the title of the Document and
     satisfy these conditions, can be treated as verbatim copying in
     other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a
     machine-readable Transparent copy along with each Opaque copy, or
     state in or with each Opaque copy a publicly-accessible
     computer-network location containing a complete Transparent copy
     of the Document, free of added material, which the general
     network-using public has access to download anonymously at no
     charge using public-standard network protocols.  If you use the
     latter option, you must take reasonably prudent steps, when you
     begin distribution of Opaque copies in quantity, to ensure that
     this Transparent copy will remain thus accessible at the stated
     location until at least one year after the last time you
     distribute an Opaque copy (directly or through your agents or
     retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of
     copies, to give them a chance to provide you with an updated
     version of the Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with
     the Modified Version filling the role of the Document, thus
     licensing distribution and modification of the Modified Version to
     whoever possesses a copy of it.  In addition, you must do these
     things in the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of
          previous versions (which should, if there were any, be listed
          in the History section of the Document).  You may use the
          same title as a previous version if the original publisher of
          that version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has less than five).

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section entitled "History", and its title, and
          add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on
          the Title Page.  If there is no section entitled "History" in
          the Document, create one stating the title, year, authors,
          and publisher of the Document as given on its Title Page,
          then add an item describing the Modified Version as stated in
          the previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in
          the "History" section.  You may omit a network location for a
          work that was published at least four years before the
          Document itself, or if the original publisher of the version
          it refers to gives permission.

       K. In any section entitled "Acknowledgments" or "Dedications",
          preserve the section's title, and preserve in the section all
          the substance and tone of each of the contributor
          acknowledgments and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document,
          unaltered in their text and in their titles.  Section numbers
          or the equivalent are not considered part of the section
          titles.

       M. Delete any section entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section as "Endorsements" or to
          conflict in title with any Invariant Section.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option
     designate some or all of these sections as invariant.  To do this,
     add their titles to the list of Invariant Sections in the Modified
     Version's license notice.  These titles must be distinct from any
     other section titles.

     You may add a section entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end
     of the list of Cover Texts in the Modified Version.  Only one
     passage of Front-Cover Text and one of Back-Cover Text may be
     added by (or through arrangements made by) any one entity.  If the
     Document already includes a cover text for the same cover,
     previously added by you or by arrangement made by the same entity
     you are acting on behalf of, you may not add another; but you may
     replace the old one, on explicit permission from the previous
     publisher that added the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination
     all of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections entitled
     "History" in the various original documents, forming one section
     entitled "History"; likewise combine any sections entitled
     "Acknowledgments", and any sections entitled "Dedications".  You
     must delete all sections entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the
     documents in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow
     this License in all other respects regarding verbatim copying of
     that document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of
     a storage or distribution medium, does not as a whole count as a
     Modified Version of the Document, provided no compilation
     copyright is claimed for the compilation.  Such a compilation is
     called an "aggregate", and this License does not apply to the
     other self-contained works thus compiled with the Document, on
     account of their being thus compiled, if they are not themselves
     derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one
     quarter of the entire aggregate, the Document's Cover Texts may be
     placed on covers that surround only the Document within the
     aggregate.  Otherwise they must appear on covers around the whole
     aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License provided that you also include the
     original English version of this License.  In case of a
     disagreement between the translation and the original English
     version of this License, the original English version will prevail.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided for under this License.  Any other
     attempt to copy, modify, sublicense or distribute the Document is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

 10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     `http://www.gnu.org/copyleft/'.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If
     the Document does not specify a version number of this License,
     you may choose any version ever published (not as a draft) by the
     Free Software Foundation.

ADDENDUM: How to use this License for your documents
----------------------------------------------------

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.1
       or any later version published by the Free Software Foundation;
       with the Invariant Sections being LIST THEIR TITLES, with the
       Front-Cover Texts being LIST, and with the Back-Cover Texts being LIST.
       A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have no Invariant Sections, write "with no Invariant Sections"
instead of saying which ones are invariant.  If you have no Front-Cover
Texts, write "no Front-Cover Texts" instead of "Front-Cover Texts being
LIST"; likewise for Back-Cover Texts.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of
free software license, such as the GNU General Public License, to
permit their use in free software.